#include "StdAfx.h"
#include "ITunesPlugin.h"
#include <iTunesCOMInterface.h>
#include "ITunesSyncClock.h"

// \z܂B
ITunesPlugin::ITunesPlugin()
{
	;
}

// j܂B
ITunesPlugin::~ITunesPlugin()
{
	;
}

// A^b`܂B
STDMETHODIMP ITunesPlugin::Attach(IARGPluginEnvironment* pEnv)
{
	if(pEnv == NULL) {
		return E_POINTER;
	}
	// iTunesIuWFNg̎擾
	IiTunes* pITunes = NULL;

	HRESULT hr = CoCreateInstance(CLSID_iTunesApp, NULL, CLSCTX_LOCAL_SERVER, IID_IiTunes, (LPVOID*)& pITunes);
	if(FAILED(hr)) {
		return hr;
	}

	hr = pEnv->AddProperty("iTunes", pITunes);
	if(FAILED(hr)) {
		return hr;
	}

	hr = S_OK;
	ITunesSyncClock* pNewClock = new ITunesSyncClock(pEnv, pITunes, & hr);
	if(FAILED(hr)) {
		delete pNewClock;
		pNewClock = NULL;
		return hr;
	}
	hr = pEnv->AddProperty("iTunesClock", pNewClock);
	if(FAILED(hr)) {
		delete pNewClock;
		pNewClock = NULL;
		return hr;
	}

	pNewClock->Release();
	pNewClock = NULL;
	pITunes->Release();
	pITunes = NULL;

	return pEnv->PrintConsole("iTunes: Attached");
}

// ܂B
STDMETHODIMP ITunesPlugin::Detach()
{
	return S_OK;
}
