#pragma once

#include <plugin/ARGBaseSyncClock.h>
#include <iTunesCOMInterface.h>
#include <plugin/IARGPluginEnvironment.h>
#include <plugin/ARGBaseWorker.h>

/**
* iTunesƂ̓pNbNłB
*/
class ITunesSyncClock : public ARGBaseSyncClock
{
public:

	/**
	* \z܂B
	*/
	ITunesSyncClock(IARGPluginEnvironment* pEnv, IiTunes* pIiTunes, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~ITunesSyncClock(void);

	/**
	* ݎ~bŎ擾܂B
	*/
	STDMETHODIMP GetCurrentTimeMS(LONGLONG* pMilliseconds);

	/**
	* Đǂ𔻒肵܂B
	*/
	STDMETHODIMP IsPlaying(bool* pValue);

	/**
	* IDispatch̎B
	*/
	STDMETHODIMP Invoke(DISPID dispIdMember, REFIID riid, LCID  lcid, WORD  wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, unsigned int *puArgErr);

private:

	/**
	* NbNp̃[J[łB
	*/
	class ClockWorker : public ARGBaseWorker
	{
	public:

		/**
		* \z܂B
		*/
		ClockWorker();

		/**
		* j܂B
		*/
		virtual ~ClockWorker();

		/**
		* s܂B
		*/
		STDMETHODIMP Invoke();

		/**
		* ݎ擾܂B
		*/
		HRESULT GetCurrentTimeMS(LONGLONG* pMillisec);

		/**
		* ݂̍ĐԂ擾܂B
		*/
		HRESULT IsPlaying(bool* pValue);

	private:

		/**
		* IuWFNgێ܂B
		*/
		ARGMutex m_mutex;

		/**
		* ĐԂێ܂B
		*/
		bool m_bPlaying;

		/**
		* x[XtickCountłB
		*/
		DWORD m_baseTickCount;

		/**
		* x[X̕błB
		*/
		LONG m_baseSec;

	};

	/**
	* vOC̎sێ܂B
	*/
	IARGPluginEnvironment* m_pEnv;

	/**
	* [J[ێ܂B
	*/
	ClockWorker* m_pWorker;

};
