#include "StdAfx.h"
#include "BasicClock.h"
#include <plugin/ARGCritSection.h>
#include <mmsystem.h>

// \z܂B
BasicClock::BasicClock()
{
	m_baseTime = 0;
	m_baseTickCount = 0;
	m_lastTime = 0;
	m_lastTickCount = 0;
	m_bPlaying = false;
}

// j܂B
BasicClock::~BasicClock(void)
{
}

// Đ擾܂B
HRESULT BasicClock::GetCurrentTimeMS(LONGLONG* pMilliseconds)
{
	if(pMilliseconds == NULL) {
		return E_POINTER;
	}

	ARGCritSection cs(& m_clockMutex);
	if(m_bPlaying == false) {
		*pMilliseconds= m_lastTime;
		return S_OK;
	}
	DWORD tickCount = timeGetTime();

	DWORD diffCount = tickCount - m_baseTickCount;

	if(diffCount < 0) {
		// ^C}[Zbg(PȎȂ̂łꂪ邪EEE)
		m_baseTime = m_lastTime;
		m_baseTickCount = 0;
		*pMilliseconds = m_baseTime;
		return S_OK;
	}

	LONGLONG ret = m_baseTime + diffCount;
	
	m_lastTime = ret;
	*pMilliseconds = ret;
	m_lastTickCount = tickCount;
	return S_OK;
}

// Đǂ擾܂B
HRESULT BasicClock::IsPlaying(bool* pValue)
{
	if(pValue == NULL) {
		return E_POINTER;
	}
	ARGCritSection cs(& m_clockMutex);
	*pValue = m_bPlaying;
	return S_OK;
}

// Đ܂B
HRESULT BasicClock::Play()
{
	ARGCritSection cs(& m_clockMutex);
	DWORD tickCount = GetTickCount();
	m_baseTime = 0;
	m_baseTickCount = tickCount;
	m_lastTime = m_baseTime;
	m_lastTickCount = tickCount;
	m_bPlaying = true;
	return S_OK;
}

// ~܂B
HRESULT BasicClock::Stop()
{
	ARGCritSection cs(& m_clockMutex);
	m_bPlaying = false;
	return S_OK;
}
