#include "StdAfx.h"
#include "MQOObject.h"

// \z܂B
MQOObject::MQOObject(IARGPluginEnvironment* pEnv)
{
	m_pEnv = pEnv;
	pEnv->AddRef();
	m_model = NULL;
}

// j܂B
MQOObject::~MQOObject(void)
{
	if(m_pEnv != NULL) {
		m_pEnv->Release();
		m_pEnv = NULL;
	}
	if(m_model != NULL) {
		mqoDeleteModel(m_model);
		m_model = NULL;
	}
}

// ǂݏo܂B
HRESULT MQOObject::Load(char* path, double scale)
{
	if(path == NULL) {
		return E_POINTER;
	}
	m_path = path;

	MQO_MODEL model = mqoCreateModel(path, scale);
	if(model == NULL) {
		return E_UNEXPECTED;
	}
	m_model = model;
	return S_OK;
}

// `悵܂B
STDMETHODIMP MQOObject::Draw()
{
	if(m_model == NULL) {
		return S_OK;
	}

	mqoCallModel(m_model);
	return S_OK;
}

// AChȌsȂ܂B
STDMETHODIMP MQOObject::OnIdle()
{
	return S_OK;
}
