#pragma once
#include "../ARGraphics.h"
#include "../../js/JSPropertyWrapper.h"
#include <ar/ar.h>
#include <GL/gl.h>

class AbstractARJSObject;

/**
* OtBbNXf̒ہB
*/
class ARJSGraphicsModel:
	public ARGraphics
{
public:

	/**
	* \z܂B
	*/
	ARJSGraphicsModel(ARWindow* pOwner);

	/**
	* j܂B
	*/
	virtual ~ARJSGraphicsModel(void);

	/**
	* JavaScriptGWݒ肵܂B
	*/
	HRESULT Attach(JSEngineContext* pContext);

	/**
	* IJSObject擾܂B
	*/
	IJSObject* GetJSObject();

	/**
	* OtBbN`悵܂B
	*/
	virtual HRESULT Draw();

	/**
	* IuWFNgt@Ng̒ǉʒm܂B
	*/
	virtual HRESULT NotifyObjectFactoryAdded(const char* name, IARGObjectFactory* pFactory);

protected:
	/**
	* xNgێ܂B
	*/
	typedef struct __tagGLVECTOR {
		GLfloat x;
		GLfloat y;
		GLfloat z;
	}GLVECTOR;

	class JSAbstractObject;

	/**
	* f`悵܂B
	*/
	virtual HRESULT DrawModel() = 0;

	/**
	* IJSObject𐶐܂B
	*/
	virtual AbstractARJSObject* CreateJSObject();

	/**
	* vpeB𐶐܂B
	*/
	virtual HRESULT CreateProperty(INamedProperty** ppProp);

	/**
	* sړێ܂B
	*/
	GLVECTOR m_translate;

	/**
	* ]ێ܂B
	*/
	GLVECTOR m_rotateBase;

	/**
	* ]ێ܂B
	*/
	GLfloat m_rotateAngle;

	/**
	* XP[Oێ܂B
	*/
	GLVECTOR m_scale;


	/**
	* vpeB̎łB
	*/
	class ModelPropertyImpl : public GraphicsPropertyImpl
	{
	public:

		/**
		* \z܂B
		*/
		ModelPropertyImpl(ARJSGraphicsModel* pOwner);

		/**
		* j܂B
		*/
		virtual ~ModelPropertyImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();
		
		/**
		* ܂B
		*/
		virtual HRESULT Init();

	protected:
		
		/**
		* doublẽvpeB擾܂B
		*/
		virtual HRESULT GetDoubleProperty(const char* name, double* pValue);
		
		/**
		* doublẽvpeBݒ肵܂B
		*/
		virtual HRESULT SetDoubleProperty(const char* name, double value);

	protected:

		/**
		* O͂܂B
		*/
		HRESULT ParseName(const char* name, string& categoryName, string& propName);

	private:

		/**
		* o擾܂B
		*/
		HRESULT GetMember(GLVECTOR* pVector, const char* propName, GLfloat** ppValue);

		/**
		* I[i[ێ܂B
		*/
		ARJSGraphicsModel* m_pOwner;
	};

	/**
	* JavaScriptIuWFNgێ܂B
	*/
	AbstractARJSObject* m_pJSObject;
};
