#pragma once
#include "ARJSGraphicsModel.h"
#include "../../common/IWorker.h"
#include "../../js/IJSFunction.h"
#include "../../common/WorkerThread.h"
#include "../IImageLoader.h"
#include "AbstractARJSObject.h"

/**
* 摜f[^B
*/
class ARJSImage :
	public ARJSGraphicsModel
{
public:

	/**
	* \z܂B
	*/
	ARJSImage(ARWindow* pOwner, IImageLoader* pImageLoader);

	/**
	* j܂B
	*/
	virtual ~ARJSImage(void);

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* 摜[h܂B
	*/
	HRESULT Load(const char* filename, double scale, jsval callback);

protected:

	/**
	* f`悵܂B
	*/
	virtual HRESULT DrawModel();

	/**
	* IJSObject𐶐܂B
	*/
	virtual AbstractARJSObject* CreateJSObject();

private:

	/**
	* \ʂ̑fށB
	*/
    static GLfloat m_matBase[4];

	/**
	* B
	*/
    static GLfloat m_matFlashShiny[1];

	/**
	* ǂݍݍς݂̉摜ݒ肵܂B
	*/
	HRESULT SetImage(IImage* pImage);

	/**
	* eNX`XV܂B
	*/
	HRESULT RefreshTexture();

	/**
	* eNX`B
	*/
	GLuint m_texture;

	/**
	* Xbhێ܂B
	*/
	WorkerThread m_workerThread;

	/**
	* 摜[_ێ܂B
	*/
	IImageLoader* m_pImageLoader;

	/**
	* 摜ێ܂B
	*/
	IImage* m_pImage;

	/**
	* eNX`̕ێ܂B
	*/
	GLfloat m_textureWidth;

	/**
	* eNX`̍ێ܂B
	*/
	GLfloat m_textureHeight;

	/**
	* XP[Oێ܂B
	*/
	double m_dScale;

	/**
	* JavaScriptIuWFNgێ܂B
	*/
	class JSObjectImpl : public AbstractARJSObject
	{
	public:

		/**
		* \z܂B
		*/
		JSObjectImpl(ARJSImage* pOwner, INamedProperty* pProp);

		/**
		* j܂B
		*/
		virtual ~JSObjectImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();

		/**
		* [h܂B
		*/
		virtual HRESULT Load(const char* file, double scale, jsval callback);

		/**
		* 摜ݒ肵܂B
		*/
		virtual HRESULT SetImage(IImage* pImage);

	protected:

		/**
		* ܂B
		*/
		virtual HRESULT InitMembers();
		
		/**
		* vpeB擾܂B
		*/
		virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);

	private:

		/**
		* LIuWFNgێ܂B
		*/
		ARJSImage* m_pOwner;

		/**
		* R[obNێ܂B
		*/
		FunctionRef m_callback;

		/**
		* vpeBێ܂B
		*/
		JSNamedProperty* m_pProp;
	};

	/**
	* 摜t@C̃[_łB
	*/
	class ImageLoader : public IImageLoaderNotify
	{
	public:

		/**
		* \z܂B
		*/
		ImageLoader(ARJSImage::JSObjectImpl* pOwner, IJSContext* pContext, double scale);

		/**
		* j܂B
		*/
		virtual ~ImageLoader();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* ̏B
		*/
		HRESULT NotifySuccess(IImage* pImage);

		/**
		* s̏B
		*/
		HRESULT NotifyFailed(const char* message);

	private:

		/**
		* I[i[ێ܂B
		*/
		ARJSImage::JSObjectImpl* m_pOwner;

		/**
		* ReLXgێ܂B
		*/
		IJSContext* m_pContext;

		/**
		* XP[B
		*/
		double m_dScale;
	};

	/**
	* MQOt@C̓ǂݍ݊ʒm܂B
	*/
	class ImageNotifier : public IJSFunction
	{
	public:

		/**
		* \z܂B
		*/
		ImageNotifier(ARJSImage::JSObjectImpl* pOwner, IImage* pImage);

		/**
		* j܂B
		*/
		virtual ~ImageNotifier();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* s܂B
		*/
		HRESULT Invoke();

	private:

		/**
		* I[i[ێ܂B
		*/
		ARJSImage::JSObjectImpl* m_pOwner;

		/**
		* ǂݍݍς݂̉摜ێ܂B
		*/
		IImage* m_pImage;
	};
};
