#pragma once
#include "../arpattern.h"
#include "../../common/AbstractProperty.h"
#include "../../js/JSPropertyWrapper.h"
#include <ar/ar.h>

/**
* JSŕҏW\ȃp^[łB
*/
class ARJSPattern :
	public ARPattern
{
public:

	/**
	* \z܂B
	*/
	ARJSPattern(const char* url, const char* pattPath, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~ARJSPattern(void);

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* JavaScriptGWݒ肵܂B
	*/
	HRESULT Attach(JSEngineContext* pContext);

	/**
	* IJSObject擾܂B
	*/
	IJSObject* GetJSObject();

protected:

	/**
	* oԂʒm܂B
	* ʓɃ}[J[oĂȂꍇApDetectedNULLݒ肳܂B
	*/
	virtual HRESULT Detect(ARMarkerInfoContainer* pDetectedC);

private:

	/**
	* }[J[CxgłB
	*/
	const static int EVENT_FOUND;

	/**
	* }[J[CxgłB
	*/
	const static int EVENT_LOST;

	/**
	* }[J[ωCxgłB
	*/
	const static int EVENT_CHANGED;

	/**
	* p^[̕ێ܂B
	*/
	double m_patternWidth;

	/**
	* p^[̒S_ێ܂B
	*/
	double m_patternCenter[2];

	/**
	* ϊsێ܂B
	*/
	double m_trans[3][4];

	/**
	* pXێ܂B
	*/
	string m_url;

	/**
	* 1Õ}[J[łB
	*/
	ARMarkerInfo* m_pOldMarkerInfo;

	class JSEventImpl;

	/**
	* vpeBłB
	*/
	class PropertyImpl : public AbstractNamedProperty
	{
	public:

		/**
		* \z܂B
		*/
		PropertyImpl(ARJSPattern* pOwner, HRESULT* phr);

		/**
		* j܂B
		*/
		virtual ~PropertyImpl();

		/**
		* j܂B
		*/
		void Destroy();

	protected:
		
		/**
		* ̃vpeB擾܂B
		*/
		HRESULT GetDoubleProperty(const char* name, double* pValue);
		
		/**
		* ̃vpeBݒ肵܂B
		*/
		HRESULT SetDoubleProperty(const char* name, double value);
		
		/**
		* int̃vpeB擾܂B
		*/
		HRESULT GetIntProperty(const char* name, int* pValue);
		
		/**
		* string̃vpeB擾܂B
		*/
		HRESULT GetStringProperty(const char* name, string& value);

	private:

		/**
		* ܂B
		*/
		HRESULT Init();

		/**
		* I[i[ێ܂B
		*/
		ARJSPattern* m_pOwner;
	};

	/**
	* JavaScriptIuWFNgێ܂B
	*/
	class JSObjectImpl : public JSNamedProperty
	{
	public:

		/**
		* \z܂B
		*/
		JSObjectImpl(ARJSPattern* pOwner, INamedProperty* pProp);

		/**
		* j܂B
		*/
		virtual ~JSObjectImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();

		/**
		* nhĂяo܂B
		*/
		HRESULT CallHandler(int type, ARMarkerInfo* pMarkerInfo);

	protected:

		/**
		* ܂B
		*/
		virtual HRESULT InitMembers();
		
		/**
		* vpeBݒ肵܂B
		*/
		virtual HRESULT SetProperty(JSContext *cx, JSObject *obj, const char* name, jsval vp);
		
		/**
		* vpeB擾܂B
		*/
		virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);

	private:

		/**
		* p^[Cxg𐶐܂B
		*/
		HRESULT CreatePatternEvent(const ARMarkerInfo* pMarkerInfo, JSObject** ppEvent);

		/**
		* LIuWFNgێ܂B
		*/
		ARJSPattern* m_pOwner;

		/**
		* }[J[𔭌CxgłB
		*/
		FunctionRef m_onFound;

		/**
		* }[J[CxgłB
		*/
		FunctionRef m_onLost;

		/**
		* }[J[ωCxgłB
		*/
		FunctionRef m_onChanged;

		/**
		* JavaScript EventIuWFNgێ܂B
		*/
		JSEventImpl* m_pJSEvent;
	};

	/**
	* CxgIuWFNg̃bp[łB
	*/
	class JSEventImpl : public JSMemberCollection
	{
	public:

		/**
		* \z܂B
		*/
		JSEventImpl(ARJSPattern* pOwner, const ARMarkerInfo* pMarkerInfo, HRESULT* phr);

		/**
		* j܂B
		*/
		virtual ~JSEventImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();

		/**
		* ARMarkerInfoݒ肵܂B
		*/
		HRESULT Set(const ARMarkerInfo* pMarkerInfo);

	protected:

		/**
		* ܂B
		*/
		virtual HRESULT InitMembers();
		
		/**
		* vpeB擾܂B
		*/
		virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);

	private:

		/**
		* LIuWFNgێ܂B
		*/
		ARJSPattern* m_pOwner;

		/**
		* }[J[`ς݂ǂێ܂B
		*/
		bool m_markerDefined;

		/**
		* }[J[ێ܂B
		*/
		ARMarkerInfo m_markerInfo;

	};

	/**
	* JavaScriptIuWFNgێ܂B
	*/
	JSObjectImpl* m_pJSObject;

	/**
	* vpeBێ܂B
	*/
	PropertyImpl* m_pProp;
};
