#pragma once
#include "ARJSGraphicsModel.h"
#include "../../common/IWorker.h"
#include "../../js/IJSFunction.h"
#include "../../common/WorkerThread.h"
#include "AbstractARJSObject.h"
#include "../../plugin/IARGObjectFactory.h"
#include "../../plugin/ARGBaseUnknown.h"

class JSDispatch;

/**
* vOCIuWFNgf[^B
*/
class ARJSPluginObject :
	public ARJSGraphicsModel
{
public:

	/**
	* \z܂B
	*/
	ARJSPluginObject(ARWindow* pOwner, IARGObjectFactory* pFactory, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~ARJSPluginObject(void);

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* 3Df[h܂B
	*/
	HRESULT Load(VARIANT* pVars, int argc, jsval callback);

	/**
	* ACh̏sȂ܂B
	*/
	virtual HRESULT OnIdle();

protected:

	/**
	* f`悵܂B
	*/
	virtual HRESULT DrawModel();

	/**
	* IJSObject𐶐܂B
	*/
	virtual AbstractARJSObject* CreateJSObject();

private:

	/**
	* ǂݍݍς݂̃fݒ肵܂B
	*/
	HRESULT SetObject(IARGObject* pObject);
	
	/**
	* IuWFNgt@Ngێ܂B
	*/
	IARGObjectFactory* m_pFactory;
	
	/**
	* IuWFNgێ܂B
	*/
	IARGObject* m_pObject;

	/**
	* Xbhێ܂B
	*/
	WorkerThread m_workerThread;


	/**
	* JavaScriptIuWFNgێ܂B
	*/
	class JSObjectImpl : public AbstractARJSObject
	{
	public:

		/**
		* \z܂B
		*/
		JSObjectImpl(ARJSPluginObject* pOwner, INamedProperty* pProp);

		/**
		* j܂B
		*/
		virtual ~JSObjectImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();

		/**
		* [h܂B
		*/
		virtual HRESULT Load(VARIANT* pVars, int argc, jsval callback);

		/**
		* fݒ肵܂B
		*/
		virtual HRESULT SetObject(HRESULT lhr, IARGObject* pObject);

	protected:

		/**
		* ܂B
		*/
		virtual HRESULT InitMembers();
		
		/**
		* vpeB擾܂B
		*/
		virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);
		
		/**
		* vpeBݒ肵܂B
		*/
		virtual HRESULT SetProperty(JSContext *cx, JSObject *obj, const char* name, jsval vp);

	private:

		/**
		* LIuWFNgێ܂B
		*/
		ARJSPluginObject* m_pOwner;

		/**
		* p[^IuWFNgێ܂B
		*/
		JSDispatch* m_pParam;

		/**
		* R[obNێ܂B
		*/
		FunctionRef m_callback;

		/**
		* ΉĂCxg̖OZbgێ܂B
		*/
		set<string> m_eventNames;

		/**
		* CxgfBXpb`̎łB
		*/
		class EventDispatcherImpl : public ARGBaseUnknown, public IARGEventDispatcher
		{
		public:

			/**
			* \z܂B
			*/
			EventDispatcherImpl(JSEngineContext* pContext, IJSObject* pOwner, jsval jsFunc, HRESULT* phr);

			/**
			* j܂B
			*/
			virtual ~EventDispatcherImpl();

			DECLARE_BASE_UNKNOWN;

			/**
			* C^tF[X擾܂B
			*/
			STDMETHODIMP QueryInterface(const IID& riid, LPVOID* ppv);

			/**
			* Cxg̏sȂ܂B
			*/
			STDMETHODIMP DispatchEvent(const VARIANT* pVars, int nVars);

		private:

			/**
			* ReLXgێ܂B
			*/
			JSEngineContext* m_pContext;

			/**
			* R[obN֐ێ܂B
			*/
			FunctionRef m_jsFunc;

			/**
			* fBXpb`XbhłB
			*/
			class Dispatcher : public IJSFunction 
			{
			public:

				/**
				* \z܂B
				*/
				Dispatcher(EventDispatcherImpl* pOwner, const VARIANT* pVars, int nVars, HRESULT* phr);

				/**
				* j܂B
				*/
				virtual ~Dispatcher();

				/**
				* j܂B
				*/
				void Destroy();

				/**
				* s܂B
				*/
				HRESULT Invoke();

			private:

				/**
				* ܂B
				*/
				HRESULT Init(const VARIANT* pVars, int nVars);

				/**
				* I[i[ێ܂B
				*/
				EventDispatcherImpl* m_pOwner;

				/**
				* ێ܂B
				*/
				VARIANT* m_pVars;

				/**
				* ̐ێ܂B
				*/
				int m_nVars;
			};

		};
	};

	/**
	* IuWFNg̃[_łB
	*/
	class ObjectLoader : public IWorker
	{
	public:

		/**
		* \z܂B
		*/
		ObjectLoader(ARJSPluginObject::JSObjectImpl* pOwner, ARWindow* pWindow, IJSContext* pContext, IARGObjectFactory* pFactory, VARIANT* pVars, int argc);

		/**
		* j܂B
		*/
		virtual ~ObjectLoader();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* s܂B
		*/
		HRESULT Invoke();

	private:

		/**
		* I[i[ێ܂B
		*/
		ARJSPluginObject::JSObjectImpl* m_pOwner;

		/**
		* EBhEێ܂B
		*/
		ARWindow* m_pWindow;
		
		/**
		* IuWFNgt@Ngێ܂B
		*/
		IARGObjectFactory* m_pFactory;

		/**
		* ReLXgێ܂B
		*/
		IJSContext* m_pContext;

		/**
		* ێ܂B
		*/
		VARIANT* m_pVars;
		
		/**
		* ̐ێ܂B
		*/
		int m_iArgc;

	};

	/**
	* IuWFNg̓ǂݍ݊ʒm܂B
	*/
	class ObjectNotifier : public IJSFunction
	{
	public:

		/**
		* \z܂B
		*/
		ObjectNotifier(ARJSPluginObject::JSObjectImpl* pOwner, HRESULT hr, IARGObject* pObject);

		/**
		* j܂B
		*/
		virtual ~ObjectNotifier();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* s܂B
		*/
		HRESULT Invoke();

	private:

		/**
		* I[i[ێ܂B
		*/
		ARJSPluginObject::JSObjectImpl* m_pOwner;

		/**
		* G[R[hێ܂B
		*/
		HRESULT m_hResult;

		/**
		* ǂݍݍς݂̃fێ܂B
		*/
		IARGObject* m_pObject;
	};

};
