#pragma once
#include "../ARGraphics.h"
#include "AbstractARJSObject.h"
#include <ar/ar.h>

class ARWindow;

/**
* [gƂȂOtBbNXB
*/
class ARJSWorld :
	public ARGraphics
{
public:

	/**
	* \z܂B
	*/
	ARJSWorld(ARWindow* pWindow);

	/**
	* j܂B
	*/
	virtual ~ARJSWorld(void);

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* JavaScriptGWݒ肵܂B
	*/
	HRESULT Attach(JSEngineContext* pContext);

	/**
	* IJSObject擾܂B
	*/
	IJSObject* GetJSObject();

	/**
	* OtBbN`悵܂B
	*/
	virtual HRESULT Draw();

private:
	
	/**
	* EBhEێ܂B
	*/
	ARWindow* m_pWindow;

	/**
	* ϊsێ܂B
	*/
	double m_trans[3][4];

	/**
	* JavaScriptIuWFNgێ܂B
	*/
	class JSObjectImpl : public AbstractARJSObject
	{
	public:

		/**
		* \z܂B
		*/
		JSObjectImpl(ARJSWorld* pOwner, INamedProperty* pProp);

		/**
		* j܂B
		*/
		virtual ~JSObjectImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();

	protected:
		
		/**
		* o܂B
		*/
		virtual HRESULT InitMembers();
		
		/**
		* vpeBݒ肵܂B
		*/
		virtual HRESULT SetProperty(JSContext *cx, JSObject *obj, const char* name, jsval vp);
		
		/**
		* vpeB擾܂B
		*/
		virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);

	private:

		/**
		* IDݒ肵܂B
		*/
		HRESULT SetTransElement(JSContext *cx, jsuint index, jsval arrv);

		/**
		* LIuWFNgێ܂B
		*/
		ARJSWorld* m_pOwner;
	};

	/**
	* JavaScriptIuWFNgێ܂B
	*/
	JSObjectImpl* m_pJSObject;

	/**
	* qm[hێ܂B
	*/
	JSArrayRef m_childNodes;
};
