#include "StdAfx.h"
#include "LocalSource.h"
#include "DiscPath.h"

// \z܂B
LocalSource::LocalSource(const char* path, HRESULT* phr)
{
	m_hFile = INVALID_HANDLE_VALUE;
	m_path = path;
	*phr = S_OK;

	m_hFile = CreateFileA(path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(m_hFile == INVALID_HANDLE_VALUE) {
		*phr = E_FAIL;
		return;
	}
}

// j܂B
LocalSource::~LocalSource()
{
	if(m_hFile != INVALID_HANDLE_VALUE) {
		CloseHandle(m_hFile);
		m_hFile = INVALID_HANDLE_VALUE;
	}
}

// j܂B
void LocalSource::Destroy()
{
	delete this;
}

// f[^ǂݍ݂܂B
HRESULT LocalSource::Read(char* pChar)
{
	if(pChar == NULL) {
		return E_POINTER;
	}
	DWORD dwLen = 1;

	BOOL bret = ReadFile(m_hFile, pChar, dwLen, & dwLen, NULL);
	if(bret == FALSE) {
		return E_FAIL;
	}
	if(dwLen == 0) {
		return S_FALSE;
	}
	return S_OK;
}

// i[ꏊpX擾܂B
HRESULT LocalSource::GetLocation(string& location)
{
	HRESULT hr = S_OK;
	DiscPath discPath(m_path.c_str(), & hr);
	if(FAILED(hr)) {
		return hr;
	}
	return discPath.GetURL(location);
}
