#include "StdAfx.h"
#include "JSEngine.h"
#include "JSEngineContext.h"
#include <jsapi.h>

// ftHgTCY
const size_t DEFAULT_STACK_CHUNK_SIZE = 8192;

// \z܂B
JSEngine::JSEngine(unsigned int maxBytes, HRESULT* phr)
{
	m_pRuntime = NULL;
	*phr = S_OK;

	// 
	m_pRuntime = JS_NewRuntime(8L * 1024L * 1024L);
	if(m_pRuntime == NULL) {
		*phr = E_FAIL;
		return;
	}

}

// j܂B
JSEngine::~JSEngine(void)
{
	if(m_pRuntime != NULL) {
		JS_DestroyRuntime(m_pRuntime);
		m_pRuntime = NULL;
	}
}

// ̃IuWFNgj܂B
void JSEngine::Destroy()
{
	delete this;
}

// ReLXg𐶐܂B
HRESULT JSEngine::CreateContext(IJSContext** ppContext)
{
	if(ppContext == NULL) {
		return E_POINTER;
	}
	if(m_pRuntime == NULL) {
		return E_UNEXPECTED;
	}
	HRESULT hr = S_OK;
	JSEngineContext* pNewContext = new JSEngineContext(m_pRuntime, DEFAULT_STACK_CHUNK_SIZE, & hr);
	if(pNewContext == NULL) {
		return E_OUTOFMEMORY;
	}
	if(FAILED(hr)) {
		pNewContext->Destroy();
		pNewContext = NULL;
		*ppContext = NULL;
		return hr;
	}

	*ppContext = pNewContext;
	return S_OK;
}
