#include "StdAfx.h"
#include "SourceJSCode.h"

// ftHg̍sԍ
const unsigned int DEFAULT_LINE_NUMBER = 1;

// \z܂B
SourceJSCode::SourceJSCode(ISource* pSource, HRESULT* phr)
{
	m_code = "";
	m_location = "";
	*phr = S_OK;

	// ǂݍ
	HRESULT hr = ReadAll(pSource, m_code);
	if(FAILED(hr)) {
		*phr = hr;
		pSource->Destroy();
		pSource = NULL;
		return;
	}
	
	hr = pSource->GetLocation(m_location);
	if(FAILED(hr)) {
		*phr = hr;
		pSource->Destroy();
		pSource = NULL;
		return;
	}

	pSource->Destroy();
	pSource = NULL;
}

// j܂B
SourceJSCode::~SourceJSCode(void)
{
}

// eLXg擾܂B
HRESULT SourceJSCode::GetText(string& text)
{
	text = m_code;
	return S_OK;
}

// t@C擾܂B
HRESULT SourceJSCode::GetFilename(string& filename)
{
	filename = m_location;
	return S_OK;
}

// sԍ擾܂B
unsigned int SourceJSCode::GetLineNumber()
{
	return DEFAULT_LINE_NUMBER;
}

// ׂẴf[^ǂݍ݂܂B
HRESULT SourceJSCode::ReadAll(ISource* pSource, string& code)
{
	if(pSource == NULL) {
		return E_POINTER;
	}

	HRESULT hr = S_OK;
	char ch = 0;
	vector<char> chars;
	while((hr = pSource->Read(& ch)) == S_OK) {
		// TODO: 
		chars.push_back(ch);

		if(ch == '\n') {
			hr = AddBuffer(code, chars);
			if(FAILED(hr)) {
				return hr;
			}
			chars.clear();
		}
	}

	hr = AddBuffer(code, chars);
	if(FAILED(hr)) {
		return hr;
	}
	chars.clear();

	return S_OK;
}

// obt@ǉ܂B
HRESULT SourceJSCode::AddBuffer(string& code, vector<char> chars)
{
	if(chars.size() == 0) {
		return S_OK;
	}

	char* pNewLine = new char[chars.size() + 1];
	if(pNewLine == NULL) {
		return E_OUTOFMEMORY;
	}
	ZeroMemory(pNewLine, sizeof(char) * (chars.size() + 1));
	for(vector<char>::size_type i = 0; i < chars.size(); i ++) {
		pNewLine[i] = chars[i];
	}

	code += pNewLine;

	delete[] pNewLine;
	pNewLine = NULL;
	return S_OK;
}
