
#include "ARGBaseUnknown.h"
#include "IARGObjectFactory.h"
#include "ARGTypeInfo.h"

/**
* IuWFNg̒ۃNXłB
*/
class ARGBaseDispatchableObject : public ARGBaseUnknown, public IARGObject, public IDispatch
{
public:

	/**
	* \z܂B
	*/
	ARGBaseDispatchableObject()
	{
		m_pTypeInfo = NULL;
	};

	/**
	* j܂B
	*/
	virtual ~ARGBaseDispatchableObject()
	{
		if(m_pTypeInfo != NULL) {
			m_pTypeInfo->Release();
			m_pTypeInfo = NULL;
		}
	};

	DECLARE_BASE_UNKNOWN;

	/**
	* C^tF[X擾܂B
	*/
	virtual STDMETHODIMP QueryInterface(const IID& riid, void** ppv)
	{
		if(ppv == NULL) {
			return E_POINTER;
		}

		if(riid == IID_IARGObject) {
			*ppv = static_cast<IARGObject*>(this);
			AddRef();
			return S_OK;
		}else if(riid == IID_IDispatch) {
			*ppv = static_cast<IDispatch*>(this);
			AddRef();
			return S_OK;
		}

		return ARGBaseUnknown::QueryInterface(riid, ppv);
	};

	/**
	* pNbNݒ肵܂B
	*/
	virtual STDMETHODIMP SetSyncClock(IARGSyncClock* pClock)
	{
		return S_OK;
	};

	/**
	* pNbN擾܂B
	*/
	virtual STDMETHODIMP GetSyncClock(IARGSyncClock** ppClock)
	{
		return S_FALSE;
	};

	/**
	* Cxg擾܂B
	*/
	virtual STDMETHODIMP GetEventCount(int* pCount)
	{
		if(pCount == NULL) {
			return E_POINTER;
		}
		*pCount = 0;
		return S_OK;
	};

	/**
	* Cxg擾܂B
	*/
	virtual STDMETHODIMP GetEvent(int index, char* pEventName, int maxLen, int* pLen)
	{
		return E_NOTIMPL;
	};

	/**
	* CxgfBXpb`ǉ܂B
	*/
	virtual STDMETHODIMP AddEventDispatcher(const char* name, IARGEventDispatcher* pDispatcher)
	{
		return E_NOTIMPL;
	};

	/**
	* CxgfBXpb`폜܂B
	* pDispatcherNULL̏ꍇnameɊւ邷ׂẴfBXpb`폜܂B
	*/
	virtual STDMETHODIMP RemoveEventDispatcher(const char* name, IARGEventDispatcher* pDispatcher)
	{
		return E_NOTIMPL;
	};

	/**
	* IDispatch̎B
	*/
	STDMETHODIMP GetTypeInfoCount(unsigned int *pCount)
	{
		if(pCount == NULL) {
			return E_POINTER;
		}
		*pCount = 1;
		return S_OK;
	};

	/**
	* IDispatch̎B
	*/
	STDMETHODIMP GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo **ppTInfo)
	{
		if(ppTInfo == NULL) {
			return E_POINTER;
		}
		if(iTInfo != 0) {
			return E_INVALIDARG;
		}
		if(m_pTypeInfo == NULL) {
			return E_UNEXPECTED;
		}

		*ppTInfo = m_pTypeInfo;
		m_pTypeInfo->AddRef();

		return S_OK;
	};

	/**
	* IDispatch̎B
	*/
	STDMETHODIMP GetIDsOfNames(REFIID riid, OLECHAR **rgszNames, unsigned int cNames, LCID lcid, DISPID *rgDispId)
	{
		if(rgszNames == NULL || rgDispId == NULL) {
			return E_POINTER;
		}
		if(m_pTypeInfo == NULL) {
			return E_UNEXPECTED;
		}

		MEMBERID* pMemIds = new MEMBERID[cNames];
		HRESULT hr = m_pTypeInfo->GetIDsOfNames(rgszNames, cNames, pMemIds);

		if(hr == S_OK) {
			for(UINT i = 0; i < cNames; i ++) {
				rgDispId[i] = pMemIds[i];
			}
		}

		delete[] pMemIds;
		pMemIds = NULL;
		return hr;
	};

protected:

	/**
	* ^Cvێ܂B
	*/
	ARGTypeInfo* m_pTypeInfo;

};
