
#include <vector>
#include "ARGBaseUnknown.h"

/**
* IuWFNg̒ۃNXłB
*/
class ARGTypeInfo : public ARGBaseUnknown, public ITypeInfo
{
public:

	/**
	* \z܂B
	*/
	ARGTypeInfo(const GUID& guid)
	{
		m_guid = guid;
	};

	/**
	* j܂B
	*/
	virtual ~ARGTypeInfo()
	{
		;
	};

	DECLARE_BASE_UNKNOWN;

	/**
	* C^tF[X擾܂B
	*/
	virtual STDMETHODIMP QueryInterface(const IID& riid, void** ppv)
	{
		if(ppv == NULL) {
			return E_POINTER;
		}

		if(riid == IID_ITypeInfo) {
			*ppv = static_cast<ITypeInfo*>(this);
			AddRef();
			return S_OK;
		}

		return ARGBaseUnknown::QueryInterface(riid, ppv);
	};

	/**
	* vfǉ܂B
	*/
	HRESULT AddElement(const wchar_t* name, MEMBERID memid, INVOKEKIND kind, VARTYPE vt, std::vector<VARTYPE> params)
	{
		if(name == NULL) {
			return E_POINTER;
		}
		ELEMENT elem(name, memid, kind, vt, params);
		m_elems.push_back(elem);
		return S_OK;
	};

	/**
	* ITypeInfo̎łB
	*/
	virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetTypeAttr( 
		/* [out] */ TYPEATTR **ppTypeAttr)
	{
		if(ppTypeAttr == NULL) {
			return E_POINTER;
		}
		TYPEATTR* pNewAttr = new TYPEATTR;
		ZeroMemory(pNewAttr, sizeof(TYPEATTR));

		pNewAttr->guid = m_guid;
		pNewAttr->cFuncs = m_elems.size();
		*ppTypeAttr = pNewAttr;

		return S_OK;
	};

	virtual HRESULT STDMETHODCALLTYPE GetTypeComp( 
		/* [out] */ __RPC__deref_out_opt ITypeComp **ppTComp)
	{
	   return E_NOTIMPL;
	};

	virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetFuncDesc( 
		/* [in] */ UINT index,
		/* [out] */ FUNCDESC **ppFuncDesc)
	{
		if(index >= m_elems.size()) {
			return TYPE_E_ELEMENTNOTFOUND;
		}
		ELEMENT& elem = m_elems[index];
		return elem.GetFuncDesc(ppFuncDesc);
	};

	virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetVarDesc( 
		/* [in] */ UINT index,
		/* [out] */ VARDESC **ppVarDesc)
	{
	   return E_NOTIMPL;
	};

	virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetNames( 
		/* [in] */ MEMBERID memid,
		/* [length_is][size_is][out] */ BSTR *rgBstrNames,
		/* [in] */ UINT cMaxNames,
		/* [out] */ UINT *pcNames)
	{
		for(std::vector<ELEMENT>::iterator it = m_elems.begin(); it != m_elems.end(); it ++) {
			ELEMENT& elem = *it;
			if(elem.m_memid != memid) {
				continue;
			}
			if(rgBstrNames != NULL && cMaxNames >= 1) {
				rgBstrNames[0] = SysAllocString(elem.m_name.c_str());
			}
			if(pcNames != NULL) {
				*pcNames = 1;
			}
			return S_OK;
		}
		return TYPE_E_ELEMENTNOTFOUND;
	};

	virtual HRESULT STDMETHODCALLTYPE GetRefTypeOfImplType( 
		/* [in] */ UINT index,
		/* [out] */ __RPC__out HREFTYPE *pRefType)
	{
	   return E_NOTIMPL;
	};

	virtual HRESULT STDMETHODCALLTYPE GetImplTypeFlags( 
		/* [in] */ UINT index,
		/* [out] */ __RPC__out INT *pImplTypeFlags)
	{
	   return E_NOTIMPL;
	};

	virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetIDsOfNames( 
		/* [size_is][in] */ LPOLESTR *rgszNames,
		/* [in] */ UINT cNames,
		/* [size_is][out] */ MEMBERID *pMemId)
	{
		for(UINT j = 0; j < cNames; j ++) {
			std::wstring targetName = rgszNames[j];
			bool find = false;
			for(std::vector<ELEMENT>::iterator it = m_elems.begin(); it != m_elems.end(); it ++) {
				ELEMENT& elem = *it;
				if(targetName == elem.m_name) {
					pMemId[j] = elem.m_memid;
					find = true;
				}
			}
			if(find == false) {
				return TYPE_E_ELEMENTNOTFOUND;
			}
		}
	   return S_OK;
	};

	virtual /* [local] */ HRESULT STDMETHODCALLTYPE Invoke( 
		/* [in] */ PVOID pvInstance,
		/* [in] */ MEMBERID memid,
		/* [in] */ WORD wFlags,
		/* [out][in] */ DISPPARAMS *pDispParams,
		/* [out] */ VARIANT *pVarResult,
		/* [out] */ EXCEPINFO *pExcepInfo,
		/* [out] */ UINT *puArgErr)
	{
	   return E_NOTIMPL;
	};

	virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetDocumentation( 
		/* [in] */ MEMBERID memid,
		/* [out] */ BSTR *pBstrName,
		/* [out] */ BSTR *pBstrDocString,
		/* [out] */ DWORD *pdwHelpContext,
		/* [out] */ BSTR *pBstrHelpFile)
	{
	   return E_NOTIMPL;
	};

	virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetDllEntry( 
		/* [in] */ MEMBERID memid,
		/* [in] */ INVOKEKIND invKind,
		/* [out] */ BSTR *pBstrDllName,
		/* [out] */ BSTR *pBstrName,
		/* [out] */ WORD *pwOrdinal)
	{
	   return E_NOTIMPL;
	};

	virtual HRESULT STDMETHODCALLTYPE GetRefTypeInfo( 
		/* [in] */ HREFTYPE hRefType,
		/* [out] */ __RPC__deref_out_opt ITypeInfo **ppTInfo)
	{
	   return E_NOTIMPL;
	};

	virtual /* [local] */ HRESULT STDMETHODCALLTYPE AddressOfMember( 
		/* [in] */ MEMBERID memid,
		/* [in] */ INVOKEKIND invKind,
		/* [out] */ PVOID *ppv)
	{
	   return E_NOTIMPL;
	};

	virtual /* [local] */ HRESULT STDMETHODCALLTYPE CreateInstance( 
		/* [in] */ IUnknown *pUnkOuter,
		/* [in] */ REFIID riid,
		/* [iid_is][out] */ PVOID *ppvObj)
	{
	   return E_NOTIMPL;
	};

	virtual HRESULT STDMETHODCALLTYPE GetMops( 
		/* [in] */ MEMBERID memid,
		/* [out] */ __RPC__deref_out_opt BSTR *pBstrMops)
	{
	   return E_NOTIMPL;
	};

	virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetContainingTypeLib( 
		/* [out] */ ITypeLib **ppTLib,
		/* [out] */ UINT *pIndex)
	{
	   return E_NOTIMPL;
	};

	/**
	* ITypeInfo̎łB
	*/
	virtual /* [local] */ void STDMETHODCALLTYPE ReleaseTypeAttr( 
		/* [in] */ TYPEATTR *pTypeAttr)
	{
		if(pTypeAttr == NULL) {
			return;
		}
		delete pTypeAttr;
		pTypeAttr = NULL;
	};

	/**
	* ITypeInfo̎łB
	*/
	virtual /* [local] */ void STDMETHODCALLTYPE ReleaseFuncDesc( 
		/* [in] */ FUNCDESC *pFuncDesc)
	{
		if(pFuncDesc == NULL) {
			return;
		}
		if(pFuncDesc->lprgelemdescParam != NULL) {
			delete[] (pFuncDesc->lprgelemdescParam);
			pFuncDesc->lprgelemdescParam = NULL;
		}
		delete pFuncDesc;
		pFuncDesc = NULL;	   
	};

	/**
	* ITypeInfo̎łB
	*/
	virtual /* [local] */ void STDMETHODCALLTYPE ReleaseVarDesc( 
		/* [in] */ VARDESC *pVarDesc)
	{
		// GetVarDesc̓T|[gOȂ̂łĂȂ
	};

private:

	/**
	* \vf\NXłB
	*/
	class ELEMENT 
	{
	public:

		/**
		* \z܂B
		*/
		ELEMENT(const wchar_t* name, MEMBERID memid, INVOKEKIND kind, VARTYPE vt, std::vector<VARTYPE> params)
		{
			m_name = name;
			m_memid = memid;
			m_kind = kind;
			m_vt = vt;
			m_params = params;
		};

		/**
		* \z܂B
		*/
		ELEMENT(const ELEMENT& source)
		{
			m_name = source.m_name;
			m_memid = source.m_memid;
			m_kind = source.m_kind;
			m_vt = source.m_vt;
			m_params = source.m_params;
		};

		/**
		* ֐̐擾܂B
		*/
		HRESULT GetFuncDesc(FUNCDESC** ppFuncDesc)
		{
			if(ppFuncDesc == NULL) {
				return E_POINTER;
			}
			FUNCDESC* pNewFuncDesc = new FUNCDESC;
			ZeroMemory(pNewFuncDesc, sizeof(FUNCDESC));

			pNewFuncDesc->cParams = m_params.size();
			pNewFuncDesc->memid = m_memid;
			pNewFuncDesc->invkind = m_kind;
			pNewFuncDesc->elemdescFunc.tdesc.vt = m_vt;
			HRESULT hr = CreateParamsDesc(& pNewFuncDesc->lprgelemdescParam);
			if(FAILED(hr)) {
				delete pNewFuncDesc;
				pNewFuncDesc = NULL;
				return hr;
			}
			*ppFuncDesc = pNewFuncDesc;
			return S_OK;
		};

		HRESULT CreateParamsDesc(ELEMDESC** ppElemDescs)
		{
			if(ppElemDescs == NULL) {
				return E_POINTER;
			}
			if(m_params.size() == 0) {
				*ppElemDescs = NULL;
				return S_OK;
			}
			ELEMDESC* pNewDescs = new ELEMDESC[m_params.size()];
			ZeroMemory(pNewDescs, sizeof(ELEMDESC) * m_params.size());
			for(std::vector<VARTYPE>::size_type i = 0; i < m_params.size(); i ++) {
				VARTYPE vt = m_params[i];
				pNewDescs[i].tdesc.vt = vt;
			}
			*ppElemDescs = pNewDescs;
			return S_OK;
		};

		/**
		* Oێ܂B
		*/
		std::wstring m_name;
		
		/**
		* o[IDێ܂B
		*/
		MEMBERID m_memid;
		
		/**
		* s^Cvێ܂B
		*/
		INVOKEKIND m_kind;

		/**
		* ^Cvێ܂B
		*/
		VARTYPE m_vt;

		/**
		* ̐ێ܂B
		*/
		std::vector<VARTYPE> m_params;

	};

	/**
	* GUIDێ܂B
	*/
	GUID m_guid;

	/**
	* \vfێ܂B
	*/
	std::vector<ELEMENT> m_elems;

};
