#pragma once

#include "../js/JSMemberCollection.h"
#include "IARGPluginEnvironment.h"
#include "IARGPlugin.h"
#include "DefaultARGPluginEnvironment.h"

class IWindow;
class ARWindow;
class JSEngineContext;

using namespace std;

/**
* vOC}l[WłB
*/
class JSPluginManager : public JSMemberCollection
{
public:

	/**
	* \z܂B
	*/
	JSPluginManager(const char* basePath, IWindow* pWindow, ARWindow* pARWindow);

	/**
	* j܂B
	*/
	virtual ~JSPluginManager(void);

	/**
	* j܂B
	*/
	void Destroy();

	/**
	* JavaScriptGWݒ肵܂B
	*/
	HRESULT SetJSEngineContext(JSEngineContext* pContext);

protected:

	/**
	* o܂B
	*/
	HRESULT InitMembers();
	
	/**
	* ֐s܂B
	*/
	HRESULT InvokeFunction(JSContext *cx, JSObject *obj, const char* name, uintN argc, jsval *argv, jsval *rval);
	
	/**
	* vpeB擾܂B
	*/
	HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);

private:

	/**
	* x[XpXێ܂B
	*/
	string m_basePath;

	/**
	* EBhEێ܂B
	*/
	IWindow* m_pWindow;

	/**
	* AREBhEIuWFNgێ܂B
	*/
	ARWindow* m_pARWindow;

	/**
	* JavaScriptReLXgێ܂B
	*/
	JSEngineContext* m_pJSEngineContext;

	/**
	* vOC̈ꗗێ܂B
	*/
	vector<pair<HMODULE, IARGPlugin*>> m_plugins;

	/**
	* s̎łB
	*/
	class ARGPluginEnvironmentImpl : public DefaultARGPluginEnvironment
	{
	public:

		/**
		* \z܂B
		*/
		ARGPluginEnvironmentImpl(JSPluginManager* pOwner);

		/**
		* j܂B
		*/
		virtual ~ARGPluginEnvironmentImpl();

		/**
		* pX擾܂B
		*/
		virtual STDMETHODIMP GetRealPath(const char* relativePath, char* absolutePath, int maxLen, int* pLen);

		/**
		* vpeBǉ܂B
		*/
		virtual STDMETHODIMP AddProperty(const char* name, IDispatch* pDisp);

		/**
		* IuWFNgt@Ngǉ܂B
		*/
		virtual STDMETHODIMP AddObjectFactory(const char* name, IARGObjectFactory* pObjectFactory);

		/**
		* R\[ɕo͂܂B
		*/
		virtual STDMETHODIMP PrintConsole(const char* text);

	private:

		/**
		* I[i[ێ܂B
		*/
		JSPluginManager* m_pOwner;
	};

	/**
	* sێ܂B
	*/
	ARGPluginEnvironmentImpl* m_pEnv;

};
