#include "StdAfx.h"
#include "PluginManager.h"
#include "JSPluginManager.h"

// \z܂B
PluginManager::PluginManager(const char* basePath, IWindow* pWindow, ARWindow* pARWindow, HRESULT* phr)
{
	m_pJSObject = NULL;
	if(basePath == NULL || pWindow == NULL || pARWindow == NULL) {
		*phr = E_POINTER;
		return;
	}
	m_pJSObject = new JSPluginManager(basePath, pWindow, pARWindow);
}

// j܂B
PluginManager::~PluginManager()
{
	// jJavaScriptGWɂĂȂ
	m_pJSObject = NULL;
}

// JavaScriptReLXgݒ肵܂B
HRESULT PluginManager::Attach(IJSContext* pContext)
{
	if(pContext == NULL) {
		return E_POINTER;
	}

	JSEngineContext* pContextImpl = (JSEngineContext*) pContext;
	HRESULT hr = m_pJSObject->SetJSEngineContext(pContextImpl);
	if(FAILED(hr)) {
		return hr;
	}
	hr = m_pJSObject->Attach(pContextImpl, NULL);
	if(FAILED(hr)) {
		return hr;
	}
	return pContextImpl->DefineGlobalProperty("plugins", m_pJSObject);
}
