#include "StdAfx.h"
#include "GLUTWindow.h"
#include <GL/glut.h>

// TODO: Window̌n(܂̓eXg)

// ftHg̃EBhE^Cgێ܂B
string GLUTWindow::m_title = "";

// ݂̃EBhEێ܂B
GLUTWindow* GLUTWindow::m_pCurrentWindow = NULL;

// ܂B
void GLUTWindow::Init(int* argc, char **argv)
{
	m_title = argv[0];

	glutInit(argc, argv);
	CoInitialize(NULL);
}

// \z܂B
GLUTWindow::GLUTWindow()
{
	m_iPrevMS = 0;
}

// j܂B
GLUTWindow::~GLUTWindow()
{
}

// j܂B
void GLUTWindow::Destroy()
{
	delete this;
}

// EBhE𐶐܂B
HRESULT GLUTWindow::Create(int width, int height)
{
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);

	/*if (FALSE) {
		if (prefRefresh) sprintf(glutGamemode, "%ix%i:%i@%i", prefWidth, prefHeight, prefDepth, prefRefresh);
		else sprintf(glutGamemode, "%ix%i:%i", prefWidth, prefHeight, prefDepth);
		glutGameModeString(glutGamemode);
		glutEnterGameMode();
	} else {*/
	glutInitWindowSize(width, height);
	glutCreateWindow(GLUTWindow::m_title.c_str());
	//}

	if(m_pNotify != NULL) {
		m_pNotify->OnCreate();
	}

	return S_OK;
}

// C[vJn܂B
HRESULT GLUTWindow::RunMainLoop()
{
	m_pCurrentWindow = this;
	glutDisplayFunc(GLUTWindow::OnDisplay);
	glutReshapeFunc(GLUTWindow::OnReshape);
	glutVisibilityFunc(GLUTWindow::OnVisibility);
	glutKeyboardFunc(GLUTWindow::OnKeyEvent);
	
	glutMainLoop();
	m_pCurrentWindow = NULL;
	return S_OK;
}

// ĕ`悵܂B
HRESULT GLUTWindow::Redraw()
{
	glutPostRedisplay();
	return S_OK;
}

// EBhE܂B
HRESULT GLUTWindow::Close()
{
	return E_NOTIMPL;
}

// L[Cxg܂B
void GLUTWindow::OnKeyEvent(unsigned char key, int x, int y)
{
	if(m_pCurrentWindow == NULL) {
		return;
	}

	m_pCurrentWindow->HandleKeyEvent(key, x, y);
}

// \Ȃ܂B
void GLUTWindow::OnVisibility(int visible)
{
	if (visible == GLUT_VISIBLE) {
		glutIdleFunc(GLUTWindow::OnMainLoop);
	} else {
		glutIdleFunc(NULL);
	}
}

// ReshapeȂ܂B
void GLUTWindow::OnReshape(int width, int height)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glViewport(0, 0, (GLsizei) width, (GLsizei) height);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

// \Ȃ܂B
void GLUTWindow::OnDisplay()
{
	if(m_pCurrentWindow == NULL) {
		return;
	}

	m_pCurrentWindow->HandleDisplay();
}

// C[v܂B
void GLUTWindow::OnMainLoop()
{
	if(m_pCurrentWindow == NULL) {
		return;
	}

	m_pCurrentWindow->HandleMainLoop();
}

// G[ꍇ̏B
void GLUTWindow::DefaultError(HRESULT hr)
{
	cout << "FATAL(GLUTWindow): " << hr + "\n";
	exit(0);
}

// L[Cxg܂B
void GLUTWindow::HandleKeyEvent(unsigned char key, int x, int y)
{
	if(m_pNotify == NULL) {
		return;
	}

	HRESULT hr = m_pNotify->OnKeyEvent(key, x, y);
	if(FAILED(hr)) {
		if(m_pNotify != NULL) {
			m_pNotify->OnError(hr);
		}else{
			DefaultError(hr);
		}
	}
}

// \Ȃ܂B
void GLUTWindow::HandleDisplay()
{
	if(m_pNotify == NULL) {
		return;
	}

	HRESULT hr = m_pNotify->OnDraw();
	
	glutSwapBuffers();

	if(FAILED(hr)) {
		if(m_pNotify != NULL) {
			m_pNotify->OnError(hr);
		}else{
			DefaultError(hr);
		}
	}
}

// C[v܂B
void GLUTWindow::HandleMainLoop()
{
	if(m_pNotify == NULL) {
		return;
	}

	// oߎԂ𔻒
	int ms = glutGet(GLUT_ELAPSED_TIME);
	float elapsed = (float)(ms - m_iPrevMS) * 0.001;
	if (elapsed < 0.01f) {
		return;
	}
	m_iPrevMS = ms;

	HRESULT hr = m_pNotify->OnIdle();
	if(FAILED(hr)) {
		if(m_pNotify != NULL) {
			m_pNotify->OnError(hr);
		}else{
			DefaultError(hr);
		}
	}
}
