#include "StdAfx.h"
#include "Win32Window.h"
#include <GL/gl.h>
#include <mmsystem.h>
#include "../common/CritSection.h"

// TODO: Window̌n(܂̓eXg)

#define TIMER_ID		0x0100

#define TIMER_INTERVAL	(1000/30)

// ftHg̃EBhE^Cgێ܂B
string Win32Window::m_title = "";

// ݂̃EBhEێ܂B
Win32Window* Win32Window::m_pCurrentWindow = NULL;

TCHAR g_szWindowName[] = TEXT("OpenGLClearWin32");

// bZ[W[vp̓IuWFNgێ܂B
Mutex g_messageLoopMutex;

// ܂B
void Win32Window::Init(int* argc, char **argv)
{
	//m_title = argv[0];

	CoInitialize(NULL);

	HINSTANCE hCurrInstance = GetModuleHandle(NULL);
	WNDCLASSEX wc;
	wc.cbSize = sizeof (WNDCLASSEX);
	wc.hInstance = hCurrInstance;
	wc.lpszClassName = g_szWindowName;
	wc.lpfnWndProc = Win32Window::WindowProc0;
	wc.style = 0;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hIconSm = NULL;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.lpszMenuName = NULL;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	if (!RegisterClassEx(&wc)) {
		// TODO: G[
		printf("Register Failed!!");
	}
}

// \z܂B
Win32Window::Win32Window()
: m_hGLRCLoading(NULL)
{
	m_hWnd = NULL;
	m_hParentWnd = NULL;
	m_bCreated = false;
	m_hCurrentDC = NULL;
	m_hCurrentDCLoading = NULL;
	m_iTimerID = TIMER_ID;
	m_bKeyDown = false;
	m_hGLRC = NULL;
	m_iNestTimer = 0;
}

// j܂B
Win32Window::~Win32Window()
{
	{
		CritSection cs(& g_messageLoopMutex);
		m_pCurrentWindow = NULL;
	}
	if(m_hWnd != NULL) {
		DestroyWindow(m_hWnd);
		m_hWnd = NULL;
	}
	if(m_hGLRC != NULL) {
		wglDeleteContext(m_hGLRC);
		m_hGLRC = NULL;
	}
	HGLRC hGLRC = NULL;
	if(m_hGLRCLoading.GetNoWait(hGLRC) == S_OK) {
		if(hGLRC != NULL) {
			wglDeleteContext(hGLRC);
			hGLRC = NULL;
		}
	}
	m_hCurrentDC = NULL;
}

// j܂B
void Win32Window::Destroy()
{
	delete this;
}

// eEBhEnhݒ肵܂B
HRESULT Win32Window::SetParent(HWND hWnd)
{
	m_hParentWnd = hWnd;
	return S_OK;
}

// EBhE𐶐܂B
HRESULT Win32Window::Create(int width, int height)
{
	HINSTANCE hCurrInstance = GetModuleHandle(NULL);

	if(m_pCurrentWindow != NULL) {
		return E_UNEXPECTED;
	}
	m_pCurrentWindow = this;

	DWORD style = 0;
	if(m_hParentWnd != NULL) {
		style = WS_CHILD | WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
	}else{
		style = WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
	}

	HWND hWnd = CreateWindow(g_szWindowName,
			g_szWindowName,
			style,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			m_hParentWnd,
			NULL,
			hCurrInstance,
			NULL);
	if (!hWnd) {
		return E_FAIL;
	}

	ShowWindow(hWnd, SW_SHOW);
	UpdateWindow(hWnd);
	SetWindowPos(hWnd, NULL, 0, 0, width, height, SWP_NOMOVE|SWP_NOZORDER);

	return S_OK;
}

// C[vJn܂B
HRESULT Win32Window::RunMainLoop()
{
	MSG msg;
	ZeroMemory(& msg, sizeof(msg));
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	m_pCurrentWindow = NULL;
	return S_OK;
}

// ĕ`悵܂B
HRESULT Win32Window::Redraw()
{
	InvalidateRect(m_hWnd,NULL,NULL);
	return S_OK;
}

// EBhE܂B
HRESULT Win32Window::Close()
{
	return E_NOTIMPL;
}

// `ݒ肵܂B
HRESULT Win32Window::SetRect(int x, int y, int width, int height)
{
	if(m_hWnd == NULL) {
		return S_FALSE;
	}
	BOOL bRet = MoveWindow(m_hWnd, x, y, width, height, true);
	if(bRet == false) {
		return E_FAIL;
	}
	return S_OK;
}

// `擾܂B
HRESULT Win32Window::GetRect(int* pX, int* pY, int* pWidth, int* pHeight)
{
	if(m_hWnd == NULL) {
		return E_UNEXPECTED;
	}
	RECT rect;
	BOOL bRet = GetWindowRect(m_hWnd, & rect);
	if(bRet == false) {
		return E_FAIL;
	}

	if(pX != NULL) {
		*pX = rect.left;
	}
	if(pY != NULL) {
		*pY = rect.top;
	}
	if(pWidth != NULL) {
		*pWidth = rect.right - rect.left;
	}
	if(pY != NULL) {
		*pHeight = rect.bottom - rect.top;
	}
	return S_OK;
}
	
// ǂݍݗpGLReLXgJn܂B
HRESULT Win32Window::BeginGLLoading()
{
	if(m_hCurrentDCLoading != NULL) {
		return E_UNEXPECTED;
	}
	HGLRC hGLRC = NULL;
	HRESULT hr = m_hGLRCLoading.Get(hGLRC);
	if(FAILED(hr)) {
		return hr;
	}
	if(m_hWnd == NULL) {
		return E_UNEXPECTED;
	}
	m_glMutex.Begin();
	HDC hDC = GetDC(m_hWnd);
	BOOL bResult = wglMakeCurrent(hDC, hGLRC);
	if(bResult == FALSE) {
		ReleaseDC(m_hWnd, hDC);
		m_glMutex.End();
		return E_UNEXPECTED;
	}
	m_hCurrentDCLoading = hDC;
	return S_OK;
}

// ǂݍݗpGLReLXgI܂B
HRESULT Win32Window::EndGLLoading()
{
	if(m_hCurrentDCLoading == NULL) {
		return E_UNEXPECTED;
	}
	if(m_hWnd == NULL) {
		return E_UNEXPECTED;
	}
	wglMakeCurrent(NULL, NULL);
	ReleaseDC(m_hWnd, m_hCurrentDCLoading);
	m_hCurrentDCLoading = NULL;
	m_glMutex.End();
	return S_OK;
}

// EBhEnh
LRESULT Win32Window::WindowProc0(HWND hWnd, UINT nMessage, WPARAM wParam, LPARAM lParam)
{
	CritSection cs(& g_messageLoopMutex);
	if(m_pCurrentWindow == NULL) {
		return DefWindowProc(hWnd, nMessage, wParam, lParam);
	}
	if(m_pCurrentWindow->m_hWnd == NULL && nMessage == WM_CREATE) {
		return m_pCurrentWindow->OnCreate(hWnd);
	}

	if(m_pCurrentWindow->m_hWnd != hWnd) {
		return DefWindowProc(hWnd, nMessage, wParam, lParam);
	}
	return m_pCurrentWindow->WindowProc(nMessage, wParam, lParam);
}

// EBhEnh
LRESULT Win32Window::WindowProc(UINT nMessage, WPARAM wParam, LPARAM lParam)
{
	LRESULT lr = 0;
	switch (nMessage) {
		case WM_PAINT:
			lr = OnPaint();
			break;
		case WM_DESTROY:
			lr = OnDestroy();
			PostQuitMessage(0);
			break;
		case WM_TIMER:
			m_iNestTimer ++;
			if(m_iNestTimer == 1) {
				lr = OnMainLoop();
			}
			m_iNestTimer --;
			break;
		case WM_SIZE:
			lr = OnSize(LOWORD(lParam), HIWORD(lParam));
			break;
		case WM_KEYDOWN:
			lr = OnKeyDown(wParam, lParam);
			break;
		case WM_KEYUP:
			lr = OnKeyUp(wParam, lParam);
			break;
		default:
			lr = DefWindowProc(m_hWnd, nMessage, wParam, lParam);
	}
	return lr;
}

// OpenGL܂B
HRESULT Win32Window::InitGL(HWND hWnd)
{
	static PIXELFORMATDESCRIPTOR pfd = {
		sizeof (PIXELFORMATDESCRIPTOR),
		1,
		PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL,
		PFD_TYPE_RGBA,
		24,
		0, 0, 0,
		0, 0, 0,
		0, 0,
		0, 0, 0, 0, 0,
		32,
		0,
		0,
		PFD_MAIN_PLANE,
		0,
		0,
		0,
		0
	};

	HDC hDC = GetDC(hWnd);
	int pfdID = ChoosePixelFormat(hDC, &pfd);	

	if (pfdID == 0) {
		return E_FAIL;
	}

	BOOL bResult = SetPixelFormat(hDC, pfdID, &pfd);
	if (bResult == FALSE) {
		return E_FAIL;
	}

	// ȉQlɎB
	// http://veelck.wordpress.com/2008/11/28/multithread-texture-loading-in-opengl/

	m_hGLRC = wglCreateContext(hDC);
	if (m_hGLRC == NULL) {
		return E_FAIL;
	}

	HGLRC hGLRC = wglCreateContext(hDC);
	if (hGLRC == NULL) {
		m_hGLRCLoading.SetFailed(E_FAIL);
		return E_FAIL;
	}

	wglShareLists(m_hGLRC, hGLRC);
	ReleaseDC(hWnd, hDC);
	return m_hGLRCLoading.Set(hGLRC);
}

// OpenGLJn܂B
HRESULT Win32Window::BeginGL()
{
	if(m_hCurrentDC != NULL) {
		return E_UNEXPECTED;
	}
	if(m_hGLRC == NULL || m_hWnd == NULL) {
		return E_UNEXPECTED;
	}
	m_glMutex.Begin();
	HDC hDC = GetDC(m_hWnd);
	BOOL bResult = wglMakeCurrent(hDC, m_hGLRC);
	if(bResult == FALSE) {
		ReleaseDC(m_hWnd, hDC);
		m_glMutex.End();
		return E_UNEXPECTED;
	}
	m_hCurrentDC = hDC;
	return S_OK;
}

// OpenGLI܂B
HRESULT Win32Window::EndGL()
{
	if(m_hCurrentDC == NULL) {
		return E_UNEXPECTED;
	}
	if(m_hGLRC == NULL || m_hWnd == NULL) {
		return E_UNEXPECTED;
	}
	wglMakeCurrent(NULL, NULL);
	ReleaseDC(m_hWnd, m_hCurrentDC);
	m_hCurrentDC = NULL;
	m_glMutex.End();
	return S_OK;
}

// G[I܂B
LRESULT Win32Window::ReturnByError(HRESULT hr)
{
	if(m_pNotify != NULL) {
		m_pNotify->OnError(hr);
	}else{
		DefaultError(hr);
	}
	return 0;
}

// L[Cxg܂B
HRESULT Win32Window::OnKeyEvent(unsigned char key, int x, int y)
{
	if(m_pNotify == NULL) {
		return S_OK;
	}

	HRESULT hr = BeginGL();
	if(FAILED(hr)) {
		return hr;
	}

	HRESULT ehr = m_pNotify->OnKeyEvent(key, x, y);

	hr = EndGL();
	if(FAILED(hr)) {
		return hr;
	}

	return ehr;
}

// \Ȃ܂B
LRESULT Win32Window::OnPaint()
{
	PAINTSTRUCT ps;
	ZeroMemory(& ps, sizeof(ps));

	m_glMutex.Begin();

	HDC hDC = BeginPaint(m_hWnd, &ps);
	wglMakeCurrent(hDC, m_hGLRC);

	//glClearColor(0.0f, 0.0f, 0.25f, 1.0f);
	//glClear(GL_COLOR_BUFFER_BIT);

	LRESULT lr = 0;
	HRESULT hr = NotifyPreDraw();
	if(FAILED(hr)) {
		lr = ReturnByError(hr);
	}

	hr = m_pNotify->OnDraw();
	if(FAILED(hr)) {
		lr = ReturnByError(hr);
	}

    SwapBuffers(hDC);

	hr = NotifyPostDraw();
	if(FAILED(hr)) {
		lr = ReturnByError(hr);
	}
	wglMakeCurrent(NULL, NULL);
	EndPaint(m_hWnd, &ps);

	m_glMutex.End();

	return 0;
}

// ꂽꍇ̏łB
LRESULT Win32Window::OnCreate(HWND hWnd)
{
	m_hWnd = hWnd;
	
	HRESULT hr = InitGL(hWnd);
	if(FAILED(hr)) {
		m_hWnd = NULL;
	
		return ReturnByError(hr);
	}

	// OnCreateOpenGLQƂ\邽
	// pӂĂ
	hr = BeginGL();
	if(FAILED(hr)) {
		return ReturnByError(hr);
	}

	if(m_pNotify != NULL) {
		m_pNotify->OnCreate();
	}

	hr = EndGL();
	if(FAILED(hr)) {
		return ReturnByError(hr);
	}

	m_bCreated = true;

	// EBhETCY̒
	RECT rect;
	ZeroMemory(& rect, sizeof(rect));
	BOOL bResult = GetWindowRect(hWnd, &rect);
	if(bResult == FALSE) {
		return 0;
	}
	LRESULT lr = OnSize(rect.right - rect.left, rect.bottom - rect.top);
	if(lr != 0) {
		return lr;
	}

	SetTimer(hWnd, m_iTimerID, TIMER_INTERVAL, NULL);
	return 0;
}

LRESULT Win32Window::OnDestroy()
{
	if (m_hGLRC != NULL) {
		wglDeleteContext(m_hGLRC);
		m_hGLRC = NULL;
	}
	KillTimer(m_hWnd, m_iTimerID);
	return 0;
}

// C[v܂B
LRESULT Win32Window::OnMainLoop()
{
	if(m_bCreated == false) {
		return 0;
	}
	if(m_pNotify == NULL) {
		return 0;
	}

	HRESULT hr = m_pNotify->OnIdle();
	if(FAILED(hr)) {
		if(m_pNotify != NULL) {
			m_pNotify->OnError(hr);
		}else{
			DefaultError(hr);
		}
	}
	return 0;
}

// TCYύX̏Ȃ܂B
LRESULT Win32Window::OnSize(int width, int height)
{
	HRESULT hr = BeginGL();
	if(FAILED(hr)) {
		return ReturnByError(hr);
	}

	// r[|[g̕ύX
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glViewport(0, 0, (GLsizei) width, (GLsizei) height);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	hr = EndGL();
	if(FAILED(hr)) {
		return ReturnByError(hr);
	}
	return 0;
}

// L[̏Ȃ܂B
LRESULT Win32Window::OnKeyDown(WPARAM wParam, LPARAM lParam)
{
	m_bKeyDown = true;
	return 0;
}

// L[̏Ȃ܂B
LRESULT Win32Window::OnKeyUp(WPARAM wParam, LPARAM lParam)
{
	if(m_bKeyDown == false) {
		return 0;
	}

	HRESULT hr = OnKeyEvent(wParam, 0, 0);

	m_bKeyDown = false;
	return 0;
}

// G[ꍇ̏B
void Win32Window::DefaultError(HRESULT hr)
{
	cout << "FATAL(Win32Window): " << hr + "\n";
}
