#include "StdAfx.h"
#include "WindowFactory.h"
#include "Win32Window.h"
#include "GLUTWindow.h"

// \z܂B
WindowFactory::WindowFactory(int type, int* argc, char** argv)
{
	m_iType = type;
	if(m_iType == WINDOW_WIN32) {
		Win32Window::Init(argc, argv);
	}else if(m_iType == WINDOW_GLUT){
		GLUTWindow::Init(argc, argv);
	}
}

// j܂B
WindowFactory::~WindowFactory(void)
{
	;
}

// ܂B
HRESULT WindowFactory::Create(IWindow** ppWindow)
{
	if(ppWindow == NULL) {
		return E_POINTER;
	}

	HRESULT hr = S_OK;
	IWindow* pNewWindow = NULL;
	if(m_iType == WINDOW_WIN32) {
		pNewWindow = new Win32Window();
	}else if(m_iType == WINDOW_GLUT){
		pNewWindow = new GLUTWindow();
	}else{
		return E_UNEXPECTED;
	}
	if(pNewWindow == NULL) {
		return E_OUTOFMEMORY;
	}
	if(FAILED(hr)) {
		pNewWindow->Destroy();
		pNewWindow = NULL;
		*ppWindow = NULL;
		return hr;
	}

	*ppWindow = pNewWindow;
	return S_OK;
}