#pragma once

#include "BaseTypes.h"

/**
* vZp̃[eBeBNXłB
*/
class CalcUtil
{
public:

	/**
	* [ɏ܂B
	*/
	static HRESULT ToZero(MMD_MATRIX* pMatrix);

	/**
	* [ɏ܂B
	*/
	static HRESULT ToZero(MMD_VECTOR3* pVector);

	/**
	* [ɏ܂B
	*/
	static HRESULT ToZero(MMD_VECTOR4* pVector);

	/**
	* Pʍs𐶐܂B
	*/
	static HRESULT GenerateIdentity(MMD_MATRIX* pMatrix);

	/**
	* Z܂B
	*/
	static HRESULT Subtract(MMD_VECTOR3* pDest, const MMD_VECTOR3* pValue1, const MMD_VECTOR3* pValue2);

	/**
	* Z܂B
	*/
	static HRESULT Add(MMD_VECTOR3* pDest, const MMD_VECTOR3* pValue1, const MMD_VECTOR3* pValue2);

	/**
	* Z܂B
	*/
	static HRESULT Multiply(MMD_VECTOR4* pDest, const MMD_VECTOR4* pValue1, const MMD_VECTOR4* pValue2);

	/**
	* Z܂B
	*/
	static HRESULT Multiply(MMD_MATRIX* pDest, const MMD_MATRIX* pValue1, const MMD_MATRIX* pValue2);

	/**
	* K܂B
	*/
	static HRESULT Normalize(MMD_VECTOR3* pDest, const MMD_VECTOR3* pSource);

	/**
	* K܂B
	*/
	static HRESULT Normalize(MMD_VECTOR4* pDest, const MMD_VECTOR4* pSource);

	/**
	* ԂsȂ܂B
	*/
	static HRESULT Lerp(MMD_VECTOR3* pDest, const MMD_VECTOR3* pValue1, const MMD_VECTOR3* pValue2, float weight);

	/**
	* ԂsȂ܂B
	*/
	static HRESULT Lerp(MMD_VECTOR4* pDest, const MMD_VECTOR4* pValue1, const MMD_VECTOR4* pValue2, float weight);

	/**
	* ԂsȂ܂B
	*/
	static HRESULT Lerp(MMD_MATRIX* pDest, const MMD_MATRIX* pValue1, const MMD_MATRIX* pValue2, float weight);

	/**
	* tsvZ܂B
	*/
	static HRESULT Inverse(MMD_MATRIX* pDest, const MMD_MATRIX* pSource);

	/**
	* ςvZ܂B
	*/
	static HRESULT DotProduct(float* dp, const MMD_VECTOR3 *pValue1, const MMD_VECTOR3 *pValue2);

	/**
	* OςvZ܂B
	*/
	static HRESULT CrossProduct(MMD_VECTOR3* pDest, const MMD_VECTOR3* pValue1, const MMD_VECTOR3* pValue2);

	/**
	* NH[^jIsɕϊ܂B
	*/
	static HRESULT QuaternionToMatrix(MMD_MATRIX* pDest, const MMD_VECTOR4* pQuat);

	/**
	* sɂϊsȂ܂B
	*/
	static HRESULT Transform(MMD_VECTOR3* pDest, const MMD_VECTOR3* pSource, const MMD_MATRIX* pMatrix);

	/**
	* sɂ]sȂ܂B
	*/
	static HRESULT Rotate(MMD_VECTOR3* pDest, const MMD_VECTOR3* pSource, const MMD_MATRIX* pMatrix);

	/**
	* NH[^jI𐶐܂B
	*/
	static HRESULT CreateAxis(MMD_VECTOR4 *pDest, const MMD_VECTOR3 *pAxis, float rotAngle);

	/**
	* ]̎擾sȂ܂B
	*/
	static HRESULT ToEuler(MMD_VECTOR3* pAngle, const MMD_VECTOR4* pQuat);

	/**
	* NH[^jI𐶐܂B
	*/
	static HRESULT CreateEuler(MMD_VECTOR4* pQuat, const MMD_VECTOR3* pAngle);

	/**
	* pxsȂ܂B
	*/
	static HRESULT LimitAngle(MMD_VECTOR4* pDest, const MMD_VECTOR4* pSource);

private:
	// CX^X͋܂B

	CalcUtil(void);
	~CalcUtil(void);
};
