#pragma once

#include "IMMDTextureProvider.h"

class MMDVertexList;
class MMDMaterial;
class MMDBone;
class MMDMorp;
class MMDIK;
class IDataMutex;

/**
* MMD̃fłB
*/
class MMDModel
{
public:

	/**
	* \z܂B
	*/
	DLL_DECL MMDModel();

	/**
	* j܂B
	*/
	DLL_DECL virtual ~MMDModel();

	/**
	* PMDt@CJ܂B
	*/
	DLL_DECL HRESULT OpenPMD(const char* path);

	/**
	* VMDt@CJ܂B
	*/
	DLL_DECL HRESULT OpenVMD(const char* path);

	/**
	* eNX`܂B
	*/
	DLL_DECL HRESULT Prepare(IMMDTextureProvider* pTextureProvider);

	/**
	* XP[Oݒ肵܂B
	*/
	DLL_DECL HRESULT SetScale(float scale);

	/**
	* XP[O擾܂B
	*/
	DLL_DECL HRESULT GetScale(float* pScale);

	/**
	* [Vj܂B
	*/
	DLL_DECL HRESULT ClearMotion();

	/**
	* XVsȂ܂B
	*/
	DLL_DECL HRESULT UpdateAsync(IDataMutex* pMutex, float frameNo);

	/**
	* `sȂ܂B
	*/
	DLL_DECL HRESULT DrawAsync(IDataMutex* pMutex);

	/**
	* \ݒ肵܂B
	*/
	DLL_DECL HRESULT SetFace(const char* faceName);

	/**
	* \擾܂B
	*/
	DLL_DECL HRESULT GetFaceCount(int* pCount);

	/**
	* \擾܂B
	*/
	DLL_DECL HRESULT GetFaceName(int index, string& faceName);

	/**
	* Bone擾܂B
	*/
	DLL_DECL HRESULT GetBoneCount(int* pCount);

	/**
	* Bone擾܂B
	*/
	DLL_DECL HRESULT GetBoneName(int index, string& boneName);

	/**
	* IK擾܂B
	*/
	DLL_DECL HRESULT GetIKCount(int* pCount);

	/**
	* IK擾܂B
	*/
	DLL_DECL HRESULT GetIKTargetName(int index, string& ikName);

	/**
	* IKLǂ擾܂B
	*/
	DLL_DECL HRESULT IsIKEnabled(int index, bool* pValue);

	/**
	* IKLǂݒ肵܂B
	*/
	DLL_DECL HRESULT SetIKEnabled(int index, bool value);

	/**
	* őt[擾܂B
	*/
	DLL_DECL HRESULT GetMaxFrame(int* pFrameNo);

	/**
	* _obt@Zbg܂B
	*/
	DLL_DECL HRESULT ResetVertexes();

	/**
	* XLjOsXV܂B
	*/
	DLL_DECL HRESULT UpdateSkinning();

	/**
	* _obt@XV܂B
	*/
	DLL_DECL HRESULT UpdateVertexBuffer();

	/**
	* [VXV܂B
	*/
	DLL_DECL HRESULT UpdateMotion(float elapsedFrame);

private:

	/**
	* XP[Oێ܂B
	*/
	float m_scale;

	/**
	* _Xgێ܂B
	*/
	MMDVertexList* m_pVertexList;

	/**
	* Boneێ܂B
	*/
	vector<MMDBone*> m_bones;

	/**
	* Materialێ܂B
	*/
	vector<MMDMaterial*> m_materials;

	/**
	* \ێ܂B
	*/
	vector<MMDMorp*> m_morps;

	/**
	* IKێ܂B
	*/
	vector<MMDIK*> m_iks;

};
