
// HTML Generating Plugin for Carabiner BEITEL
// http://beitel.carabiner.jp/

var menu = window.popup;
menu.appendChild(menu.createSeparator());

var comp = menu.createMenuItem("yzwlab HTML出力", exportYzwlabHTML);
menu.appendChild(comp);

/**
* yzwlab HTML出力を行ないます。
*/
function exportYzwlabHTML(ev)
{
    var colHeaders = document.columnHeaders;
    var fnColIndex = -1;
    var nameColIndex = -1;
    for(var i = 0; i < colHeaders.length; i ++) {
        var colHeader = colHeaders[i];
        if(colHeader.text == "ファイル名") {
            fnColIndex = i;
        }
        if(colHeader.text == "名前") {
            nameColIndex = i;
        }
    }
    if(fnColIndex < 0) {
        alert("カラムが見つかりません: ファイル名");
        return;
    }
    if(nameColIndex < 0) {
        alert("カラムが見つかりません: 名前");
        return;
    }
    exportYzwlabHTMLNode(ev.currentTarget, null, fnColIndex, nameColIndex, null, null);
}

function exportYzwlabHTMLNode(node, out, fnColIndex, nameColIndex, context, nextTag)
{
    var col = node.getColumn(fnColIndex);
    var localOut = null;
    var title = null;
    var endTag = null;
    var newCtx = null;
    var childNextTag = null;
    var html = "";
    if(col.text != "") {
        alert(node.text + ": " + col.text);
        var fn = "ext/yzwlabhtml/" + col.text;
        localOut = new java.io.PrintWriter(new java.io.OutputStreamWriter(new java.io.FileOutputStream(fn), "utf-8"));
        html = "<a href=\"" + col.text + "\">" + node.text + "</a>";
        title = node.text;
        
        localOut.println("<html>");
        localOut.println("    <head>");
        localOut.println("        <title>" + title + "</title>");
        localOut.println("        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
        localOut.println("        <link rel=\"STYLESHEET\" href=\"default.css\" type=\"text/css\">");
        localOut.println("    </head>");
        localOut.println("    <body>");
        
        newCtx = new Object();
        newCtx.filename = col.text;
        newCtx.title = title;
        if(node.getColumn(nameColIndex).text != null) {
            newCtx.title = node.getColumn(nameColIndex).text;
        }
        
        childNextTag = "h2";
    }else{
        html = convertHTMLText(node.text);
    }
    if(out != null && context != null) {
        var h3Col = new java.awt.Color(0xC6E2FF);
        if(node.text == "#list") {
            out.println("<div class=\"list\"><ul>");
            endTag = "</ul></div>"
            childNextTag = "li";
        }else if(node.text == "#code") {
            out.println("<div class=\"code\">");
            endTag = "</div>"
            childNextTag = "";
        }else if(nextTag == "h2") {
            var name = node.getColumn(nameColIndex).text;
            out.println("<h2><a name=\"" + name + "\">" + html + "</a></h2>");
        }else if(nextTag == "li") {
            out.println("<li>" + html + "</li>");
        }else if(nextTag == "") {
            out.println(html);
        }else if(node.background != null) {
            if(h3Col.red == node.background.red && h3Col.blue == node.background.blue && h3Col.green == node.background.green) {
                out.print("<h3>");
                out.print(html);
                out.println("</h3>");
            }else{
                alert("不明な色: " + node.background);
            }
        }else{
            out.print("<p>");
            out.print(html);
            out.println("</p>");
        }
    }
    var childOut = out;
    if(localOut != null) {
        childOut = localOut;
    }
    var childCtx = context;
    if(newCtx != null) {
        childCtx = newCtx;
        childCtx.parent = context;
    }
    var childNodes = node.childNodes;
    var h1Print = false;
    var indexPrint = -1;
    if(isLicenseNode(node)) {
        var textOut = new java.io.PrintWriter(new java.io.OutputStreamWriter(new java.io.FileOutputStream("ext/yzwlabhtml/" + "LICENSE.txt"), "utf-8"));
        exportLicenseNode(node, childOut, textOut, context);
        textOut.flush();
        textOut.close();
    }else{
	    for(var i = 0; i < childNodes.length; i ++) {
	        var childNode = childNodes.item(i);
	        if(localOut != null && childNode.text == "#version" && h1Print == false) {
	            childOut.println("<h1>" + title + " <span class=\"version\">version " + childNode.childNodes.item(0).text + "</span></h1>");
	            h1Print = true;
	            indexPrint = i + 1;
	            continue;
	        }else if(h1Print == false && localOut != null) {
	            childOut.println("<h1>" + title + "</h1>");
	            h1Print = true;
	            indexPrint = i;
	        }
	        if(indexPrint >= 0) {
	            if(context != null) {
	                childOut.println("<div class=\"navi\"><a href=\"" + context.filename + "\">" + context.title + "に戻る</a></div>");
	            }
	            childOut.println("<div class=\"list\"><ul>");
	            for(var j = indexPrint; j < childNodes.length; j ++) {
	                var h2Node = childNodes.item(j);
	                childOut.println("<li><a href=\"#" + h2Node.getColumn(nameColIndex).text + "\">" + h2Node.text + "</a></li>");
	            }
	            childOut.println("</ul></div>");
	            indexPrint = -1;
	        }
	        exportYzwlabHTMLNode(childNode, childOut, fnColIndex, nameColIndex, childCtx, childNextTag);
	    }
    }
    if(endTag != null) {
        out.println(endTag);
    }
    if(localOut != null) {
        localOut.println("    <p><br></p>");
	            if(context != null) {
	                childOut.println("<div class=\"navi\"><a href=\"" + context.filename + "\">" + context.title + "に戻る</a></div>");
	            }
        localOut.println("    <hr>");
        localOut.println("    Copyright(C) 2010 やざわラボ");
        localOut.println("    </body>");
        localOut.println("</html>");
        localOut.flush();
        localOut.close();
        localOut = null;
    }
}

function exportLicenseNode(node, htmlOut, textOut, context)
{
    htmlOut.println("<h1>" + node.text + "</h1>");
    if(context != null) {
        htmlOut.println("<div class=\"navi\"><a href=\"" + context.filename + "\">" + context.title + "に戻る</a></div>");
    }
    htmlOut.println("<div class=\"list\"><ul>");
    var childNodes = node.childNodes;
    for(var j = 0; j < childNodes.length; j ++) {
        var h2Node = childNodes.item(j);
        var text = getLicenseNodeText(h2Node.text);
        htmlOut.println("<li><a href=\"" + h2Node.text + "\">" + text + "</a></li>");
    }
    htmlOut.println("</ul></div>");
    
    for(var j = 0; j < childNodes.length; j ++) {
        var h2Node = childNodes.item(j);
        var text = getLicenseNodeText(h2Node.text);
        htmlOut.println("<h2><a name=\"" + h2Node.text.substring(1) + "\">" + text + "</a></h2>");
        textOut.println("================================");
        textOut.println(text);
        textOut.println("================================");
	textOut.println();
	if(h2Node.text == "#thislicense") {
            exportThisLicenseNode(h2Node, htmlOut, textOut);
        }else if(h2Node.text == "#libslicense"){
            exportLibsLicenseNode(h2Node, htmlOut, textOut);
        }else{
            alert("不明なノード: " + h2Node.text);
        }
        textOut.println();
    }
}

function isLicenseNode(node)
{
    var childNodes = node.childNodes;
    for(var j = 0; j < childNodes.length; j ++) {
        if(getLicenseNodeText(childNodes.item(j).text) != null) {
            return true;
        }
    }
    return false;
}

function getLicenseNodeText(text)
{
    if(text == "#thislicense") {
        return "このソフトウェアに関して";
    }else if(text == "#libslicense") {
        return "ライブラリに関して";
    }
    return null;
}

function exportThisLicenseNode(node, htmlOut, textOut)
{
    var childNodes = node.childNodes;
    for(var j = 0; j < childNodes.length; j ++) {
        var childNode = childNodes.item(j);
        htmlOut.println("<p>" + convertHTMLText(childNode.text) + "</p>");
        textOut.println(childNode.text);
        textOut.println();
    }

}

function exportLibsLicenseNode(node, htmlOut, textOut)
{
    var childNodes = node.childNodes;
    for(var j = 0; j < childNodes.length; j ++) {
        var childNode = childNodes.item(j);
        htmlOut.println("<h3>" + childNode.text + "</h3>");
        htmlOut.println("<p>");
        textOut.println("* " + childNode.text);
        var childChildNodes = childNode.childNodes;
        for(var i = 0; i < childChildNodes.length; i ++) {
            var childChildNode = childChildNodes.item(i);
            var text = childChildNode.text;
            if(i == 0) {
                htmlOut.println(childNode.text + "は<a href=\"" + text + "\">" + text + "</a>で入手可能です。<br>");
                textOut.println(childNode.text + "は " + text + " で入手可能です。");
            }else if(text == "#license") {
                text = childChildNode.childNodes.item(0).text;
                htmlOut.println("<strong>" + text + "</strong>に基づき配布を許可されています。<br>");
                textOut.println(text + "に基づき配布を許可されています。");
            }else if(text == "#attention") {
                text = childChildNode.childNodes.item(0).text;
                htmlOut.println(text + "<br>");
                textOut.println(text);
            }
        }
        htmlOut.println("</p>");
        textOut.println();
    }
}

function convertHTMLText(text)
{
	var html = "";
        var pos = -1;
        while((pos = text.indexOf("\n")) >= 0) {
            html += text.substring(0, pos).replace("&", "&amp;").replace("<", "&lt;").replace(">", "&gt;");
            html += "<br>";
            text = text.substring(pos + 1);
        }
        html += text.replace("&", "&amp;").replace("<", "&lt;").replace(">", "&gt;");
        return html;
}

